import json
import os
import subprocess

from django.core.management.base import BaseCommand
from django.conf import settings

from ...render import render_infinity


class Command(BaseCommand):
    help = 'render infinity'

    def add_arguments(self, parser):
        parser.add_argument('--prefix', action='store', dest='prefix', default="/srv/t_for_time", help='prefix to build clips in')
        parser.add_argument('--duration', action='store', dest='duration', default="3600", help='target duration of all fragments in seconds')

    def handle(self, **options):
        render_infinity(options)
