import json
import os
import subprocess

from django.core.management.base import BaseCommand
from django.conf import settings

from ...render import render_all


class Command(BaseCommand):
    help = 'genrate kdenlive porject and render'

    def add_arguments(self, parser):
        parser.add_argument('--prefix', action='store', dest='prefix', default="/srv/t_for_time", help='prefix to build clips in')
        parser.add_argument('--duration', action='store', dest='duration', default="3600", help='target duration of all fragments in seconds')
        parser.add_argument('--offset', action='store', dest='offset', default="1024", help='inital offset in pi')
        parser.add_argument('--no-video', action='store_true', dest='no_video', default=False, help='don\'t render video')

    def handle(self, **options):
        render_all(options)
